@using Entities
@using Business
@using DataAccess

@inject IDbContextFactory<inventory_context> ContextFactory
@inject NavigationManager navManager


@if (DataLoading)
{
    <h4>@loading_message</h4>
}

<EditForm Model="oCategory">
    <div class="form-group">
        <label for="">Codigo</label>
        <InputText class="form-control" @bind-Value="oCategory.CatCode" />
    </div>
    <br>

    <div class="form-group">
        <label for="">Nombre de la Categoria</label>
        <InputText class="form-control" @bind-Value="oCategory.CatName" />
    </div>
    <br>

    <input type="button" value="Actualizar Categoria" @onclick="UpdateCategory">

</EditForm>



@code
{
    [Parameter] public int ParamCatId {get; set;}
    private bool DataLoading = false;
    private string loading_message = "Loading Product ..";
    
    Category oCategory = new();
    B_Category bCategory = null!;

    protected override async Task OnInitializedAsync()
    {
        if (DataLoading)
        {
            return;
        }

        try
        {
            DataLoading = true;
            bCategory = new (ContextFactory);
            oCategory = await bCategory.GetCategoryById(ParamCatId);            
        }
        catch (System.Exception ex)
        {
            throw ex;
        }
        finally
        {
            DataLoading = false;
        }        
        await base.OnInitializedAsync();
    }

    private async Task UpdateCategory()
    {
        if (bCategory is not null)
        {
            await bCategory.UpdateCategory(oCategory);
            oCategory = new();
            StateHasChanged();
            navManager.NavigateTo("category/list");
        }
    }

}